MODULE STRAIN_CALC

  IMPLICIT NONE

CONTAINS

   SUBROUTINE STRISO(EESUM,EEDIF,EEZZ,EERZ,CHI)
        Use Input_Data
     IMPLICIT NONE
     REAL, INTENT(IN   ) :: CHI
     REAL, INTENT(  OUT) :: EESUM,EEDIF,EEZZ,EERZ

     DOUBLE PRECISION :: AASUM,AADIF,AARZ

     !!! COMMON
     REAL :: RHO,ZETA,ETA
     COMMON /QAGON/RHO,ZETA,ETA

     ETA=1.E0
     CALL PREST(AASUM,AADIF,AARZ)

     EESUM = - BIAUX*(AASUM+CHI)+BISUM*CHI
     EEZZ  = + BIAUX*(AASUM+CHI)+BIZZ*CHI
     EEDIF = BIAUX*(AADIF-CHI)
     EERZ  = BIAUX*AARZ
     
   END SUBROUTINE STRISO

   SUBROUTINE STRANISO(EESUM,EEDIF,EEZZ,EERZ,CHI)
        Use Input_Data
     IMPLICIT NONE
     REAL, INTENT(IN   ) :: CHI
     REAL, INTENT(  OUT) :: EESUM,EEDIF,EEZZ,EERZ

     DOUBLE PRECISION :: AASUM1,AADIF1,AARZ1,&
                         AASUM2,AADIF2,AARZ2

     !!! COMMON
     REAL :: RHO,ZETA,ETA
     COMMON /QAGON/RHO,ZETA,ETA

     ETA=ETA1
     CALL PREST(AASUM1,AADIF1,AARZ1)
     ETA=ETA2
     CALL PREST(AASUM2,AADIF2,AARZ2)

     EESUM = (2.E0*EPSA + CN1_2G)*CHI + &
             (CN02_1*AASUM2 - CN02_2*AASUM1)/ETA_DIF
     EEDIF = +CN1_2G*CHI - &
             (CN02_1*AADIF2 - CN02_2*AADIF1)/ETA_DIF
     EEZZ  = EPSC*CHI + &
             (CN42_1*AASUM2 - CN42_2*AASUM1)/ETA_DIF
     EERZ  = (CN31_1*AARZ2 - CN31_2*AARZ1)/ETA_DIF

!    WRITE(12,'(10(E15.8,1X))')ZETA,RHO,AASUM1,AASUM2,AADIF1,AADIF2

     RETURN
     
   END SUBROUTINE STRANISO

   SUBROUTINE PREST(AASUM,AADIF,AARZ)

      Use Input_Data, ONLY: RD,RC,ZC
   
   IMPLICIT NONE

!! 'dummy' and local variables !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

   DOUBLE PRECISION AASUM,AADIF,AARZ,RO,ZE

!! GAG Variables  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

   INTEGER, PARAMETER :: LIMITE=100
   DOUBLE PRECISION AL,AU,ABSERR,EPSABS,EPSREL,WORK(4*LIMITE)
   INTEGER IER,IWORK(LIMITE),KEY,LAST,LENW,LIMIT,NEVAL

   DOUBLE PRECISION, EXTERNAL :: I_FA00,I_FA10,I_FA20

   !!! COMMON
   REAL :: RHO,ZETA,ETA
   COMMON /QAGON/RHO,ZETA,ETA

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   
    RO=RHO
    ZE=ZETA
    AL=0.D0
    AU=DBLE(RD)

    EPSABS=0.D0
    EPSREL=1.D-4
    KEY=6
    LIMIT=LIMITE
    LENW=LIMIT*4
    
    CALL DQAG(I_FA00,AL,AU,EPSABS,EPSREL,KEY,AASUM,ABSERR,NEVAL, &
             IER,LIMIT,LENW,LAST,IWORK,WORK)
    IF (IER.NE.0) &
       CALL DQAG_CHECK("FA00","AASUM",AASUM,ABSERR,RO*RC,ZE*ZC,NEVAL,IER,LAST)


    CALL DQAG(I_FA10,AL,AU,EPSABS,EPSREL,KEY,AARZ,ABSERR,NEVAL, &
             IER,LIMIT,LENW,LAST,IWORK,WORK)

    IF (IER.NE.0) &
       CALL DQAG_CHECK("FA10","AARZ",AARZ,ABSERR,RO*RC,ZE*ZC,NEVAL,IER,LAST)

    CALL DQAG(I_FA20,AL,AU,EPSABS,EPSREL,KEY,AADIF,ABSERR,NEVAL, &
             IER,LIMIT,LENW,LAST,IWORK,WORK)

    IF (IER.NE.0) &
       CALL DQAG_CHECK("FA20","AADIF",AADIF,ABSERR,RO*RC,ZE*ZC,NEVAL,IER,LAST)

   RETURN
   END SUBROUTINE PREST

   SUBROUTINE DQAG_CHECK(FUNC,RESNAME,RES,ABSERR,RO,ZE,NEVAL,IER,LAST)
   IMPLICIT NONE
   CHARACTER(LEN=*)    :: FUNC,RESNAME
   DOUBLE PRECISION    :: RES,ABSERR,RO,ZE
   INTEGER             :: NEVAL,IER,LAST
     WRITE(6,*)"ERROR AT: RHO: ",RO," ZETA: ",ZE
     WRITE(6,*)"QAG ",TRIM(FUNC)," ",TRIM(RESNAME)," RESULT=",RES
     WRITE(6,*)"QAG ABSERR=",ABSERR
     WRITE(6,*)"QAG NEVAL=",NEVAL
     WRITE(6,*)"QAG IER=",IER
     WRITE(6,*)"QAG LAST=",LAST

     RETURN
   END SUBROUTINE DQAG_CHECK

  FUNCTION FA00(RHO,ZETA,RHOP,ZM,ETA) RESULT(A00)
        Use Input_Data, ONLY: RC,ZC
        Use ELIPT_MOD

    IMPLICIT NONE
    DOUBLE PRECISION, INTENT(IN) :: RHO,ZETA,RHOP,ZM,ETA
    DOUBLE PRECISION :: A00

    DOUBLE PRECISION ::  PI,DPI
    DOUBLE PRECISION :: SRRHOP,RRHOP15,SM,S0,DELTAM,DELTA0,&
                        KM,K0,CKM,CK0,KKM,KK0,EKM,EK0

      PI  = DATAN(1.D0)*4.D0
      DPI = 2.D0*PI

      SRRHOP=SQRT(RHO*RHOP)
      RRHOP15=SQRT(RHO*RHOP)**3

      SM = DSIGN(1.D0,ZETA-ZM)
      S0 = DSIGN(1.D0,ZETA)

      DELTAM = DSQRT(ETA)*DABS(ZETA-ZM)*ZC/RC
      DELTA0 = DSQRT(ETA)*DABS(ZETA)*ZC/RC

      KM = 2.D0*DSQRT( RHO*RHOP/((RHO+RHOP)**2+DELTAM**2) )
      K0 = 2.D0*DSQRT( RHO*RHOP/((RHO+RHOP)**2+DELTA0**2) ) 

      CKM = (1.D0-KM**2)
      CK0 = (1.D0-K0**2)      

      CALL ELIPT0(KM,KKM,EKM)
      CALL ELIPT0(K0,KK0,EK0)

       IF (RHO .EQ. 0.D0) THEN
          A00 = ( SM*DELTAM/SQRT(RHOP**2+DELTAM**2)**3) &
               -(S0*DELTA0/SQRT(RHOP**2+DELTA0**2)**3 )
          A00 = A00/2.D0
          RETURN
       END IF

      A00 = SM*DELTAM*KM**3/(2.D0*DPI*CKM*RRHOP15)*EKM &
           -S0*DELTA0*K0**3/(2.D0*DPI*CK0*RRHOP15)*EK0 

      A00 = A00/2.D0   

      RETURN

  
  END FUNCTION FA00

  FUNCTION FA10(RHO,ZETA,RHOP,ZM,ETA) RESULT(A10)
        Use Input_Data, ONLY: RC,ZC
        Use ELIPT_MOD

    IMPLICIT NONE
    DOUBLE PRECISION, INTENT(IN) :: RHO,ZETA,RHOP,ZM,ETA
    DOUBLE PRECISION :: A10

    DOUBLE PRECISION ::  PI,DPI
    DOUBLE PRECISION :: SRRHOP,RRHOP15,SM,S0,DELTAM,DELTA0,&
                        KM,K0,CKM,CK0,KKM,KK0,EKM,EK0

      PI  = DATAN(1.D0)*4.D0
      DPI = 2.D0*PI

      SRRHOP=DSQRT(RHO*RHOP)
      RRHOP15=DSQRT(RHO*RHOP)**3

      SM = DSIGN(1.D0,ZETA-ZM)
      S0 = DSIGN(1.D0,ZETA)

      DELTAM = DSQRT(ETA)*DABS(ZETA-ZM)*ZC/RC
      DELTA0 = DSQRT(ETA)*DABS(ZETA)*ZC/RC

      KM = 2.D0*DSQRT( RHO*RHOP/((RHO+RHOP)**2+DELTAM**2) )
      K0 = 2.D0*DSQRT( RHO*RHOP/((RHO+RHOP)**2+DELTA0**2) ) 

      CKM = (1.D0-KM**2)
      CK0 = (1.D0-K0**2)      

      CALL ELIPT0(KM,KKM,EKM)
      CALL ELIPT0(K0,KK0,EK0)
         
       IF (RHO .EQ. 0.D0) THEN
          A10 = 0.D0
          RETURN
       END IF

       A10 = KM/(4.D0*DPI*CKM*RHO*RRHOP15)  &
               * ( KM**2*(RHO**2-RHOP**2-DELTAM**2)*EKM   &
                 + 4.D0*RHO*RHOP*CKM*KKM )   &
          - K0/(4.D0*DPI*CK0*RHO*RRHOP15)  &
               * ( K0**2*(RHO**2-RHOP**2-DELTA0**2)*EK0 &
                 + 4.D0*RHO*RHOP*CK0*KK0 )  
          
       A10 = A10/2.D0 

      RETURN
  
  END FUNCTION FA10
  
  FUNCTION FA20(RHO,ZETA,RHOP,ZM,ETA) RESULT(A20)
        Use Input_Data, ONLY: RC,ZC
        Use ELIPT_MOD

    IMPLICIT NONE
    DOUBLE PRECISION, INTENT(IN) :: RHO,ZETA,RHOP,ZM,ETA
    DOUBLE PRECISION :: A20

    DOUBLE PRECISION ::  PI,DPI
    DOUBLE PRECISION :: SRRHOP,RRHOP15,SM,S0,DELTAM,DELTA0,&
                        KM,K0,CKM,CK0,KKM,KK0,EKM,EK0

    DOUBLE PRECISION ::  SIRHO, PSIM, PSI0

      PI  = DATAN(1.D0)*4.D0
      DPI = 2.D0*PI

      SRRHOP=DSQRT(RHO*RHOP)
      RRHOP15=DSQRT(RHO*RHOP)**3

      SM = DSIGN(1.D0,ZETA-ZM)
      S0 = DSIGN(1.D0,ZETA)

      DELTAM = DSQRT(ETA)*DABS(ZETA-ZM)*ZC/RC
      DELTA0 = DSQRT(ETA)*DABS(ZETA)*ZC/RC

      SIRHO = DSIGN(1.D0,RHO-RHOP)

      KM = 2.D0*DSQRT( RHO*RHOP/((RHO+RHOP)**2+DELTAM**2) )
      K0 = 2.D0*DSQRT( RHO*RHOP/((RHO+RHOP)**2+DELTA0**2) ) 

      CKM = (1.D0-KM**2)
      CK0 = (1.D0-K0**2)      

      CALL ELIPT0(KM,KKM,EKM)
      CALL ELIPT0(K0,KK0,EK0)
         
      PSIM = DASIN( DELTAM/DSQRT((RHO-RHOP)**2+DELTAM**2) )
      PSI0 = DASIN( DELTA0/DSQRT((RHO-RHOP)**2+DELTA0**2) )


       IF (RHO .EQ. 0.D0) THEN
          A20 = 0.D0
          RETURN
       END IF
 
       A20 = SM*( -DELTAM*KM**3/(4.D0*PI*CKM*RRHOP15) * EKM &
                 -( DELTAM*KM/(PI*SRRHOP)*KKM  &
                  + SIRHO*LAMBDA0(PSIM,KM) )/RHO**2 )  &
           - S0*( -DELTA0*K0**3/(4.D0*PI*CK0*RRHOP15) * EK0 &
                 -( DELTA0*K0/(PI*SRRHOP)*KK0  &
                  + SIRHO*LAMBDA0(PSI0,K0) )/RHO**2 ) 

       A20 = A20/2.D0

      RETURN
  
  END FUNCTION FA20

END MODULE STRAIN_CALC
